package org.apache.xindice.client.corba.db;

//
// Interface definition : DocumentSet
//
// @author OpenORB Compiler
//
public abstract class DocumentSetPOA extends org.omg.PortableServer.Servant
		implements DocumentSetOperations, org.omg.CORBA.portable.InvokeHandler
{
	public DocumentSet _this()
	{
		return DocumentSetHelper.narrow(_this_object());
	}

	public DocumentSet _this( org.omg.CORBA.ORB orb )
	{
		return DocumentSetHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/DocumentSet:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("hasMoreDocuments") )
		{

			try
			{
				boolean _arg_result = hasMoreDocuments();

				_output = handler.createReply();
				_output.write_boolean(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("getNextDocument") )
		{
			long arg0_in = org.apache.xindice.client.corba.db.TimestampHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.EncodedBuffer _arg_result = getNextDocument(arg0_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("remove") )
		{

			remove();

			_output = handler.createReply();

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
