package org.apache.xindice.client.corba.db;

//
// Helper class for : Database
//
// @author OpenORB Compiler
//
public class DatabaseHelper
{
	//
	// Insert Database into an any
	// @param	a an any
	// @param	t Database value
	//
	public static void insert( org.omg.CORBA.Any a, org.apache.xindice.client.corba.db.Database t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract Database from an any
	// @param	a an any
	// @return the extracted Database value
	//
	public static org.apache.xindice.client.corba.db.Database extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.apache.xindice.client.corba.db.DatabaseHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the Database TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"Database");
		}
		return _tc;
	}

	//
	// Return the Database IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:org/apache/xindice/client/corba/db/Database:1.0";

	//
	// Read Database from a marshalled stream
	// @param	istream the input stream
	// @return the readed Database value
	//
	public static org.apache.xindice.client.corba.db.Database read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.apache.xindice.client.corba.db.Database )istream.read_Object( org.apache.xindice.client.corba.db._DatabaseStub.class );
	}

	//
	// Write Database into a marshalled stream
	// @param	ostream the output stream
	// @param	value Database value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.apache.xindice.client.corba.db.Database value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to Database
	// @param	obj the CORBA Object
	// @return Database Object
	//
	public static Database narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Database )
			return ( Database)obj;

		if ( obj._is_a( id() ) )
		{
			_DatabaseStub stub = new _DatabaseStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to Database
	// @param	obj the CORBA Object
	// @return Database Object
	//
	public static Database unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof Database )
			return ( Database)obj;

		_DatabaseStub stub = new _DatabaseStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
