package org.apache.xindice.client.corba.db;

//
// Holder class for : Key
//
// @author OpenORB Compiler
//
final public class KeyHolder
		implements org.omg.CORBA.portable.Streamable
{
	//
	// Internal Key value
	//
	public byte[] value;

	//
	// Default constructor
	//
	public KeyHolder()
	{ }

	//
	// Constructor with value initialisation
	// @param	initial	the initial value
	//
	public KeyHolder( byte[] initial )
	{
		value = initial;
	}

	//
	// Read Key from a marshalled stream
	// @param	istream the input stream
	//
	public void _read( org.omg.CORBA.portable.InputStream istream )
	{
		value = KeyHelper.read(istream);
	}

	//
	// Write Key into a marshalled stream
	// @param	ostream the output stream
	//
	public void _write( org.omg.CORBA.portable.OutputStream ostream )
	{
		KeyHelper.write(ostream,value);
	}

	//
	// Return the Key TypeCode
	// @return a TypeCode
	//
	public org.omg.CORBA.TypeCode _type()
	{
		return KeyHelper.type();
	}

}
