package org.apache.xindice.client.corba.db;

//
// Helper class for : ServantManagement
//
// @author OpenORB Compiler
//
public class ServantManagementHelper
{
	//
	// Insert ServantManagement into an any
	// @param	a an any
	// @param	t ServantManagement value
	//
	public static void insert( org.omg.CORBA.Any a, org.apache.xindice.client.corba.db.ServantManagement t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract ServantManagement from an any
	// @param	a an any
	// @return the extracted ServantManagement value
	//
	public static org.apache.xindice.client.corba.db.ServantManagement extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return org.apache.xindice.client.corba.db.ServantManagementHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the ServantManagement TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"ServantManagement");
		}
		return _tc;
	}

	//
	// Return the ServantManagement IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0";

	//
	// Read ServantManagement from a marshalled stream
	// @param	istream the input stream
	// @return the readed ServantManagement value
	//
	public static org.apache.xindice.client.corba.db.ServantManagement read( org.omg.CORBA.portable.InputStream istream )
	{
		return( org.apache.xindice.client.corba.db.ServantManagement )istream.read_Object( org.apache.xindice.client.corba.db._ServantManagementStub.class );
	}

	//
	// Write ServantManagement into a marshalled stream
	// @param	ostream the output stream
	// @param	value ServantManagement value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.apache.xindice.client.corba.db.ServantManagement value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to ServantManagement
	// @param	obj the CORBA Object
	// @return ServantManagement Object
	//
	public static ServantManagement narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ServantManagement )
			return ( ServantManagement)obj;

		if ( obj._is_a( id() ) )
		{
			_ServantManagementStub stub = new _ServantManagementStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to ServantManagement
	// @param	obj the CORBA Object
	// @return ServantManagement Object
	//
	public static ServantManagement unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof ServantManagement )
			return ( ServantManagement)obj;

		_ServantManagementStub stub = new _ServantManagementStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
