package org.apache.xindice.client.corba.db;

//
// Interface definition : Collection
//
// @author OpenORB Compiler
//
public class _CollectionStub extends org.omg.CORBA.portable.ObjectImpl
		implements Collection
{
	static final String[] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/Collection:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.apache.xindice.client.corba.db.CollectionOperations.class;

	//
	// Operation getName
	//
	public String getName()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getName",true);
					_input = this._invoke(_output);
					String _arg_ret = _input.read_string();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getName",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getName();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getCanonicalName
	//
	public String getCanonicalName()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getCanonicalName",true);
					_input = this._invoke(_output);
					String _arg_ret = _input.read_string();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getCanonicalName",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getCanonicalName();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getCollectionManager
	//
	public org.apache.xindice.client.corba.db.CollectionManager getCollectionManager()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getCollectionManager",true);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.CollectionManager _arg_ret = org.apache.xindice.client.corba.db.CollectionManagerHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getCollectionManager",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getCollectionManager();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getParentCollection
	//
	public org.apache.xindice.client.corba.db.Collection getParentCollection()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getParentCollection",true);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.Collection _arg_ret = org.apache.xindice.client.corba.db.CollectionHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getParentCollection",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getParentCollection();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation listCollections
	//
	public String[] listCollections()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("listCollections",true);
					_input = this._invoke(_output);
					String[] _arg_ret = org.apache.xindice.client.corba.db.NamesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("listCollections",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.listCollections();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getCollection
	//
	public org.apache.xindice.client.corba.db.Collection getCollection(String path)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getCollection",true);
					org.apache.xindice.client.corba.db.NameHelper.write(_output,path);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.Collection _arg_ret = org.apache.xindice.client.corba.db.CollectionHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getCollection",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getCollection( path);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation insertDocument
	//
	public String insertDocument(String nam, org.apache.xindice.client.corba.db.EncodedBuffer doc)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("insertDocument",true);
					org.apache.xindice.client.corba.db.NameHelper.write(_output,nam);
					org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,doc);
					_input = this._invoke(_output);
					String _arg_ret = _input.read_string();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("insertDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.insertDocument( nam,  doc);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation removeDocument
	//
	public void removeDocument(String id)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("removeDocument",true);
					_output.write_string(id);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("removeDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					_self.removeDocument( id);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer getDocument(String id, long stamp)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getDocument",true);
					_output.write_string(id);
					org.apache.xindice.client.corba.db.TimestampHelper.write(_output,stamp);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.EncodedBuffer _arg_ret = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getDocument( id,  stamp);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation setDocument
	//
	public void setDocument(String id, org.apache.xindice.client.corba.db.EncodedBuffer doc)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("setDocument",true);
					_output.write_string(id);
					org.apache.xindice.client.corba.db.EncodedBufferHelper.write(_output,doc);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("setDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					_self.setDocument( id,  doc);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getDocuments
	//
	public org.apache.xindice.client.corba.db.DocumentSet getDocuments()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getDocuments",true);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.DocumentSet _arg_ret = org.apache.xindice.client.corba.db.DocumentSetHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getDocuments",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getDocuments();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation listDocuments
	//
	public String[] listDocuments()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("listDocuments",true);
					_input = this._invoke(_output);
					String[] _arg_ret = org.apache.xindice.client.corba.db.NamesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("listDocuments",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.listDocuments();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getDocumentCount
	//
	public int getDocumentCount()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getDocumentCount",true);
					_input = this._invoke(_output);
					int _arg_ret = _input.read_long();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getDocumentCount",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.getDocumentCount();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation createNewOID
	//
	public String createNewOID()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("createNewOID",true);
					_input = this._invoke(_output);
					String _arg_ret = _input.read_string();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("createNewOID",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.createNewOID();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation queryCollection
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer queryCollection(String style, String query, org.apache.xindice.client.corba.db.NamedVal[] namespaces, long stamp)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("queryCollection",true);
					_output.write_string(style);
					org.apache.xindice.client.corba.db.ValueHelper.write(_output,query);
					org.apache.xindice.client.corba.db.NamedValsHelper.write(_output,namespaces);
					org.apache.xindice.client.corba.db.TimestampHelper.write(_output,stamp);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.EncodedBuffer _arg_ret = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("queryCollection",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.queryCollection( style,  query,  namespaces,  stamp);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation queryDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer queryDocument(String style, String query, org.apache.xindice.client.corba.db.NamedVal[] namespaces, String id, long stamp)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("queryDocument",true);
					_output.write_string(style);
					org.apache.xindice.client.corba.db.ValueHelper.write(_output,query);
					org.apache.xindice.client.corba.db.NamedValsHelper.write(_output,namespaces);
					_output.write_string(id);
					org.apache.xindice.client.corba.db.TimestampHelper.write(_output,stamp);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.EncodedBuffer _arg_ret = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("queryDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.queryDocument( style,  query,  namespaces,  id,  stamp);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation invokeXMLObject
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer invokeXMLObject(String uri)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("invokeXMLObject",true);
					_output.write_string(uri);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.EncodedBuffer _arg_ret = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("invokeXMLObject",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.CollectionOperations _self = ( org.apache.xindice.client.corba.db.CollectionOperations ) _so.servant;
				try
				{
					return _self.invokeXMLObject( uri);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove
	//
	public void remove()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.ServantManagementOperations _self = ( org.apache.xindice.client.corba.db.ServantManagementOperations ) _so.servant;
				try
				{
					_self.remove();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
